<?
// $Id: common.inc.php,v 1.86 2006/01/16 22:39:53 ch_girardot Exp $
//
// BioArray Software Environment (BASE) - homepage http://base.thep.lu.se/
// Copyright (C) 2002-2005 Lao Saal, Carl Troein, Johan Vallon-Christersson, Charles Girardot
//
// This file is part of BASE.
//
// BASE is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// BASE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
	require_once("display.inc.php");
	require_once("db.inc.php");
	require_once("basecontrol.inc.php");

	// Check the PHP version and configuration

	if(version_compare(phpversion(), "4.3.0RC2") < 0)
	{
		// I so feel like adding RTFM to this message.
		mydie("Unsupported PHP version. BASE requires at least PHP 4.3.0.\n");
	}

	// Require that errors are logged
	if(!ini_get("log_errors"))
	{
		mydie("Error: log_errors is Off\n\n".
		"BASE requires the PHP option log_errors to be On, because it's ".
		"the only way some errors can be found, and it's the only way we ".
		"can be sure that the admin has a chance to see the errors, and ".
		"hopefully this will reduce the number of bogus bug reports\n".
		"\nphp.ini location: ".get_cfg_var("cfg_file_path")."\n");
	}

	// Set the log level to what it should always be these days
	error_reporting(E_ALL);
	// How to report errors: to a file, and never to "stdout"
	ini_set("html_errors", 0);		// Possibly PHP_INI_SYSTEM only.
	ini_set("display_errors", 0);

	// Prevent nasty log filling in case of an undefined index in a loop
	ini_set("ignore_repeated_errors", "1");

	// Issue a warning if register_globals is on
	if(ini_get("register_globals"))
	{
		error_log("BASE warning: register_globals is on. ".
			"Disable it for better security.");
	}

	if(ini_get("magic_quotes_runtime") || ini_get("magic_quotes_gpc"))
	{
		error_log("magic_quotes_runtime/gpc must be off for BASE to run");
		mydie("Error: magic_quotes_runtime/gpc must be off for BASE to run.\n".
			"Make sure that magic_quotes_gpc and magic_quotes_runtime are ".
			"set to 'off' in php.ini\n".
			"\nphp.ini location: ".get_cfg_var("cfg_file_path")."\n");
	}

	// Handle CR and CRLF properly
	ini_set("auto_detect_line_endings", "1");

	// In the case that PHP was compiled with --enable-memory-limit we may
	// need to increase the memory limit. Since we don't know how much we
	// might need, we just set it as high as possible.
	ini_set("memory_limit", -1);

	// Check the configuration

	if(!isset($config) || !is_array($config))
	{
		error_log("\$config not defined in common.inc.php - ".
			"check your getconfig paths (www/getconfig.inc.php)");
		mydie("Configuration error - see log for details\n");
	}

	$cfgvars = array("sessionTimeout", "RDBMS", "dbHost", "dbUser",
		"dbPassword", "dbDatabase", "dbDynamic", "cookieName",
		"displayCookie", "adminName", "adminEmail", "gnuplot", "mime.types",
		"rootDir", "uploadDir", "tempDir", "jobDir", "rawFileDir",
		"rawImageDir", "printMapDir", "protocolDir", "logDir",
		"spotImageDir", "magemlDir", "umask", "pluginArguments",
		"useJobRunner", "useFlock", "userName", "affymode",
		"magemlJavaOptions", "java", "magemlPrefix");
	if(isset($config["RDBMS"]) && $config["RDBMS"] == "mysql")
		$cfgvars[] = "mysql.localinfile";
	foreach($cfgvars as $v)
	{
		if(!isset($config[$v]))
		{
			error_log("Required configuration variable \$config[$v] ".
				"not defined");
			mydie("Configuration error - see error log for details\n");
		}
	}
	unset($cfgvars);
	unset($v);

	// Set the umask as soon as possible so any files and dirs we create
	// have the correct value.
	umask($config["umask"]);

	// The name of the dynamic database has to be turned into something
	// that can be put in an SQL statement as the prefix of a table name.
	db_dynamic_db_prepare($config["dbDynamic"]);

	// This appeared before we had chosen the name 'BASE'. It used to be in
	// the config file but then it wasn't updated with each new version and
	// that was... well, not a Good Thing.
	$config["codename"]			= "BASE 1.2.17";

	// The schema version required by this version of BASE
	define("BASE_SCHEMA_VERSION", "1.2.20");

	// Import variables into the global scope in a controlled fashion. Only
	// location and oldlocation and all variables with names starting with
	// i_ will be imported. Warnings will be issued about all other variables
	// that are not defined in $ignored.

	// PHP 4.2.3 takes the command line as the query string when run
	// as an interpreter (with #!). The contents of $_GET are then
	// rather odd, and should be ignored.
	if(!isset($_SERVER["QUERY_STRING"]))
		$_GET = array();

	// I don't know why some people have 'SITESERVER' defined.
	$ignored = array_flip(array("l", "m", "location", "oldlocation",
		"SITESERVER", "MAX_FILE_SIZE"));
	if(isset($_REQUEST["location"]))
		$location =& $_REQUEST["location"];
	if(isset($_REQUEST["oldlocation"]))
		$oldlocation =& $_REQUEST["oldlocation"];
	for(reset($_GET); list($key) = each($_GET); )
	{
		if(!is_string($key))
			continue;
		// Deal with broken browsers that don't understand &amp;
		if(substr($key, 0, 4) == "amp;")
			$key = substr($key, 4);
		if(isset($ignored[$key]))
			continue;
		if(substr($key, 0, 2) == "i_")
			$GLOBALS[$key] =& $_GET[$key];
		else
			error_log("Mysterious GET variable '$key' in $_SERVER[PHP_SELF]");
	}
	for(reset($_POST); list($key) = each($_POST); )
	{
		if(!is_string($key) || isset($ignored[$key]))
			continue;
		if(substr($key, 0, 2) == "i_")
			$GLOBALS[$key] =& $_POST[$key];
		else
			error_log("Mysterious POST variable '$key' in $_SERVER[PHP_SELF]");
	}
	unset($ignored, $key);


	// Create a self-referencing URL for use with redirects
	// This doesn't really belong here, but we don't have anywhere
	// better to put it.
	if(isset($_SERVER["HTTPS"]))
		$config["urlhost"] = "https://";
	else
		$config["urlhost"] = "http://";
	if(isset($_SERVER["HTTP_HOST"]))
		$config["urlhost"] .= $_SERVER["HTTP_HOST"];
	else if(isset($_SERVER["SERVER_NAME"]))
		$config["urlhost"] .= $_SERVER["SERVER_NAME"];
	else if(isset($_SERVER["SERVER_ADDR"]))
		$config["urlhost"] .= $_SERVER["SERVER_ADDR"];
	else $config["urlhost"] .= "unknown";
	if(isset($_SERVER["SCRIPT_NAME"]))
	{
		$config["urlpath"] = ereg_replace("^/*((.*/)?)[^/]*\$",
			"/\\1", $_SERVER["SCRIPT_NAME"]);
	}
	else $config["urlpath"] = "/";

	// Create the object that handles text sizes and other display options
	// and if possible give it information from the client.
	$curDisplay = new Display();
	if(isset($_COOKIE[$config["displayCookie"]]))
		$curDisplay->parseCookie($_COOKIE[$config["displayCookie"]]);


	// {B}ASE {U}ser {A}ccess definitions.
	// A superuser has all access levels, as well as full write access to
	// all items.
	define("BUA_SUPERUSER",		1 << 0);		// Almighty
	define("BUA_SUPERREADER",	1 << 30);	// Full read access

	define("BUA_SHARE_WORLD",	1 << 25);	// Share with 'world'

	define("BUA_ADMIN_USER",	1 << 1);		// Edit users
	define("BUA_USER_READ",		1 << 2);		// Read user list

	define("BUA_NEWS_EDIT",		1 << 3);		// Edit site news
	define("BUA_USER_READ_MORE", 1 << 4);	// Read more user info

	define("BUA_VOCABULARY_EDIT", 1 << 5);	// Edit and Manage vocabulary 

	define("BUA_ARRAY_READ",	1 << 6);		// Read array and plate info
	define("BUA_ARRAY_EDIT",	1 << 7);		// Edit arrays and plates

	define("BUA_WARE_EDIT",		1 << 8);		// Edit hard/software
	define("BUA_PROTOCOL_EDIT",1 << 9);		// Edit protocols
	define("BUA_PROGRAM_EDIT",	1 << 10);	// Edit plugins

	define("BUA_BIO_READ",		1 << 11);	// Read sample/extract/label
	define("BUA_BIO_EDIT",		1 << 12);	// Edit sample/extract/label
	define("BUA_BIO_TISSUE",	1 << 13);	// Edit sample origins
	define("BUA_BIO_ANNOT",		1 << 14);	//	Edit sample annotation types

	define("BUA_PROGRAM_READ",	1 << 15);	// Read plugins

	define("BUA_HYB_READ",		1 << 16);	// Read hybridizations
	define("BUA_HYB_EDIT",		1 << 17);	// Edit hybridizations

	define("BUA_UPLOAD",			1 << 18);	// Upload files
	define("BUA_WIZZZARD_EDIT",1 << 19);	// Edit file formats

	define("BUA_EXPER_READ",	1 << 20);	// Read experiments
	define("BUA_EXPER_EDIT",	1 << 21);	// Edit experiments
	define("BUA_EXPER_CREATE",	1 << 22);	// Create experiments
	define("BUA_EXPER_MAGEML",	1 << 23);	// Create MAGE-ML for experiments

	define("BUA_BROADCAST",		1 << 24);	// Chat in left frame

	define("BUA_REPORTER_READ",1 << 26);	// Read reporters
	define("BUA_REPORTER_EDIT",1 << 27);	// Edit reporters

	define("BUA_NONE",			0);			// Used where no level is required.

	// Some useful combinations
	define("BUA_ADMIN", BUA_SUPERUSER | BUA_ADMIN_USER | BUA_BROADCAST |
		BUA_PROGRAM_EDIT | BUA_NEWS_EDIT | BUA_SUPERREADER | BUA_VOCABULARY_EDIT);
	define("BUA_EDIT", BUA_ARRAY_EDIT | BUA_PROTOCOL_EDIT | BUA_BIO_TISSUE |
		BUA_BIO_ANNOT | BUA_WARE_EDIT | BUA_REPORTER_EDIT | BUA_HYB_EDIT |
		BUA_BIO_EDIT | BUA_UPLOAD | BUA_EXPER_EDIT | BUA_WIZZZARD_EDIT |
		BUA_EXPER_CREATE | BUA_EXPER_MAGEML | BUA_SHARE_WORLD);
	define("BUA_READ", BUA_ARRAY_READ | BUA_BIO_READ | BUA_REPORTER_READ |
		BUA_USER_READ | BUA_HYB_READ | BUA_EXPER_READ | BUA_USER_READ_MORE |
		BUA_PROGRAM_READ);
	define("BUA_ALL", BUA_ADMIN | BUA_EDIT | BUA_READ);


	// Affy and cDNA mode stuff

	$terms = array();
	if($config["affymode"])
	{
		$terms["def_platform"] = "Affymetrix";
	}
	else
	{
		$terms["def_platform"] = "cDNA";
	}

?>
